---

- name: Initialize computations
  set_fact:
    sw_ports: {}
    vlan_members_tagged: {}
    vlan_members_untagged: {}

- name: Compute port->host association
  include_tasks: fetch_sw_position.yml
  when: hostvars[host].chassis.name == chassis.name
  with_items: "{{ groups[blades_group] }}"
  loop_control:
    loop_var: host

# TODO: simplify when this is merged: https://github.com/ansible/ansible/pull/32738
#       the current behavior with templating cannot built integers but only strings,
#       breaking array by-index access
- name: Define base interface offset
  set_fact:
    base_iface_offset: 0
  when: chassis_module.pos == 'A1'
- name: Define base interface offset
  set_fact:
    base_iface_offset: 1
  when: chassis_module.pos == 'A2'

- name: Compute VLAN memberships
  include_tasks: fetch_vlan_membership.yml
  with_items: "{{ sw_ports }}"
  loop_control:
    loop_var: sw_port

# to get local time
- name: Collect local facts is missing
  setup:
  delegate_to: localhost
  delegate_facts: True
  when: "'localhost' not in hostvars or not hostvars['localhost'].ansible_facts"

# TODO: why is ansible_date_time.epoch also under ansible_facts???
- name: Compute change date for config
  set_fact:
    change_date: "{{ '%Y-%b-%d %a %H:%M:%S' | strftime(hostvars['localhost'].ansible_date_time.epoch) }}"

- name: "Generate configuration files"
  include_tasks: gen_config.yml

